//
//  NXFileStatWrapper.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 7/23/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef struct nx_file_stat_s *nx_file_stat_fwd_t;

@interface NXFileStatWrapper : NSObject
{
@private
	nx_file_stat_fwd_t nxFileStat;
	BOOL isFreeRequired;
}

+ (id)statWithURL:(NSURL *)fileURL
			error:(NSError **)error;

+ (id)statWithFileHandle:(FILE *)fileHandle
				   error:(NSError **)error;

+ (id)statWithFileDescriptor:(int)fileDescriptor
					   error:(NSError **)error;


+ (id)statWithNXFileStat:(nx_file_stat_fwd_t)nxFileStat
				makeCopy:(BOOL)makeCopy
				   error:(NSError **)error;

+ (id)statWithNXFileStatWrapper:(NXFileStatWrapper *)nxFileStatWrapper
						  error:(NSError **)error;


- (id)initWithURL:(NSURL *)fileURL
			error:(NSError **)error;

- (id)initWithFileHandle:(FILE *)fileHandle
				   error:(NSError **)error;

- (id)initWithFileDescriptor:(int)fileDescriptor
					   error:(NSError **)error;


- (id)initWithNXFileStat:(nx_file_stat_fwd_t)nxFileStat
				makeCopy:(BOOL)makeCopy
				   error:(NSError **)error;

- (id)initWithNXFileStatWrapper:(NXFileStatWrapper *)nxFileStatWrapper
						  error:(NSError **)error;

- (NSDate *)fileCreationDate;
- (NSDate *)fileAccessDate;
- (NSDate *)fileModificationDate;
- (unsigned long long)fileSize;

- (BOOL)getNXFileStat:(nx_file_stat_fwd_t)nxFileStat
				error:(NSError **)error;

@end
