//
//  ReplicantApplication.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/13/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiServiceManager.h"

@class ReplicantApplicationInternal;

@interface ReplicantApplication : NSObject
{
	@private
	ReplicantApplicationInternal *_internal;
}

+ (unsigned int)replicantVersionMajor;
+ (unsigned int)replicantVersionMinor;
+ (unsigned int)replicantVersionMicro;
+ (unsigned int)replicantVersionSpin;
+ (NSString *)replicantVersion;

- (id)initWithID:(CFUUIDRef)uuid;

- (void)setUserAgent:(NSString *)anUserAgent;
- (NSString *)userAgent;

- (void)setName:(NSString *)aName;
- (NSString *)name;

- (void)setVersion:(NSString *)aVersion;
- (NSString *)version;

- (CFUUIDRef)ID;

- (void)setDataDirectoryURL:(NSURL *)anURL;
- (NSURL *)dataDirectoryURL;

- (BOOL)addComponentURL:(NSURL *)anURL;
- (BOOL)addComponentDirectoryURL:(NSURL *)anURL;
- (void)loadComponents;

- (id<WasabiServiceManager>)serviceManager;

- (void)addFeature:(CFUUIDRef)featureId;
- (void)removeFeature:(CFUUIDRef)featureId;
- (BOOL)isFeatureAvailable:(CFUUIDRef)featureId;

- (void)allowFeature:(CFUUIDRef)featureId;
- (void)disallowFeature:(CFUUIDRef)featureId;
- (BOOL)isFeatureAllowed:(CFUUIDRef)featureId;
- (void)disallowAllFeatures;

- (void)disableFeaturesFilter;
- (void)enableFeaturesFilter;
- (BOOL)isFeaturesFilterEnabled;

@end

