//
//  WasabiArtworkManager.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 5/3/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiDispatchable.h"
#import "WasabiServiceIdentity.h"
#import "WasabiMetadataFields.h"
#import "WasabiArtworkWrapper.h"

FOUNDATION_EXTERN CFUUIDRef const WasabiArtworkManagerGUID;
FOUNDATION_EXTERN CFUUIDRef const WasabiArtworkManagerTypeID;

@protocol WasabiArtworkManager <WasabiDispatchable, WasabiServiceIdentity>

@required


- (WasabiArtworkWrapper *)artworkForURL:(NSURL *)anURL
							   andField:(WasabiMetadataField)aField;

- (WasabiArtworkWrapper *)artworkForURL:(NSURL *)anURL
							   andField:(WasabiMetadataField)aField
						 retrivingFlags:(WasabiMetadataFlags)aFlags;

- (WasabiArtworkWrapper *)artworkForURL:(NSURL *)anURL
							   andField:(WasabiMetadataField)aField
						 retrivingFlags:(WasabiMetadataFlags)aFlags
								  error:(NSError **)error;

- (WasabiArtworkWrapper *)albumCoverForURL:(NSURL *)anURL;

- (WasabiArtworkWrapper *)albumCoverForURL:(NSURL *)anURL
						 retrivingFlags:(WasabiMetadataFlags)aFlags;

- (WasabiArtworkWrapper *)albumCoverForURL:(NSURL *)anURL
						 retrivingFlags:(WasabiMetadataFlags)aFlags
								  error:(NSError **)error;


@end
