//
//  WasabiArtworkWrapper.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 7/24/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "NXDataWrapper.h"

@interface WasabiArtworkWrapper : NSObject
{
@private
	void *artwork;
	BOOL isFreeRequired;
}

+ (id)artwork;

+ (id)artworkWithArtwork:(void *)artwork
				makeCopy:(BOOL)makeCopy
				   error:(NSError **)error;

+ (id)artworkWithArtworkWrapper:(WasabiArtworkWrapper *)artworkWrapper
						  error:(NSError **)error;


- (id)initWithArtwork:(void *)artwork
			 makeCopy:(BOOL)makeCopy
				error:(NSError **)error;

- (id)initWithArtworkWrapper:(WasabiArtworkWrapper *)artworkWrapper
					   error:(NSError **)error;

- (NXDataWrapper *)nxData;
- (unsigned int)imageWidth;
- (unsigned int)imageHeight;
- (NSSize)imageSize;
- (NSData *)imageData;
- (NSString *)description;
- (NSString *)mimeType;
- (NSURL *)sourceURL;
- (NSDate *)fileCreationDate;
- (NSDate *)fileModificationDate;
- (NSDate *)fileAccessDate;
- (unsigned long long)fileSize;

- (BOOL)getArtwork:(void *)artwork
			 error:(NSError **)error;

@end

