//
//  WasabiDispatchable.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/19/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol WasabiDispatchable <NSObject>

@required
- (void *)underlyingObject;

- (BOOL)isDispatchCodeValid:(size_t)code;
- (void *)queryInterfaceObject:(CFUUIDRef)interfaceId 
						 error:(NSError **)error;
- (id<WasabiDispatchable>)queryInterface:(CFUUIDRef)interfaceId;
- (id<WasabiDispatchable>)queryInterface:(CFUUIDRef)interfaceId 
								   error:(NSError **)error;

@end
