//
//  WasabiMetadata.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/23/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiDispatchable.h"
#import "WasabiMetadataFields.h"
#import "WasabiArtworkWrapper.h"
#import "NXDataWrapper.h"


@protocol WasabiMetadata <WasabiDispatchable>

@required

- (NSString *)stringValueFromField:(WasabiMetadataField)aField;
- (NSString *)stringValueFromField:(WasabiMetadataField)aField
						   atIndex:(unsigned int)anIndex
							 error:(NSError **)error;

- (long long)longLongValueFromField:(WasabiMetadataField)aField;
- (long long)longLongValueFromField:(WasabiMetadataField)aField
							atIndex:(unsigned int)anIndex
							  error:(NSError **)error;

- (double)doubleValueFromField:(WasabiMetadataField)aField;
- (double)doubleValueFromField:(WasabiMetadataField)aField
					   atIndex:(unsigned int)anIndex
						 error:(NSError **)error;

- (WasabiArtworkWrapper *)artworkValueFromField:(WasabiMetadataField)aField;

- (WasabiArtworkWrapper *)artworkValueFromField:(WasabiMetadataField)aField
								 retrivingFlags:(WasabiMetadataFlags)aFlags;

- (WasabiArtworkWrapper *)artworkValueFromField:(WasabiMetadataField)aField
										atIndex:(unsigned int)anIndex
								 retrivingFlags:(WasabiMetadataFlags)aFlags
										  error:(NSError **)error;

- (NXDataWrapper *)binaryValueFromField:(WasabiMetadataField)aField;

- (NXDataWrapper *)binaryValueFromField:(WasabiMetadataField)aField
						 retrivingFlags:(WasabiMetadataFlags)aFlags;

- (NXDataWrapper *)binaryValueFromField:(WasabiMetadataField)aField
								atIndex:(unsigned int)anIndex
						 retrivingFlags:(WasabiMetadataFlags)aFlags
								  error:(NSError **)error;


- (id<WasabiMetadata>)metadataValueFromField:(WasabiMetadataField)aField;
- (id<WasabiMetadata>)metadataValueFromField:(WasabiMetadataField)aField
									 atIndex:(unsigned int)anIndex
									   error:(NSError **)error;

- (NSData *)serialize;
- (NSData *)serializeAndReturnError:(NSError **)error;

@end
