//
//  WasabiMetadataEditor.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/23/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiDispatchable.h"
#import "WasabiMetadataFields.h"
#import "WasabiArtworkWrapper.h"

@protocol WasabiMetadataEditor <WasabiDispatchable>

@required

- (BOOL)save;
- (BOOL)saveWithError:(NSError **)error;

- (BOOL)setStringValue:(NSString *)value
			  forField:(WasabiMetadataField)field
			 withIndex:(unsigned int)index
				 error:(NSError **)error;


- (BOOL)setLongLongValue:(long long)value
				forField:(WasabiMetadataField)field
			   withIndex:(unsigned int)index
				   error:(NSError **)error;

- (BOOL)setDoubleValue:(double)value
			  forField:(WasabiMetadataField)field
			 withIndex:(unsigned int)index
				 error:(NSError **)error;

- (BOOL)setArtwork:(WasabiArtworkWrapper *)value
		  forField:(WasabiMetadataField)field
		 withIndex:(unsigned int)index
			 error:(NSError **)error;

- (BOOL)setArtwork:(WasabiArtworkWrapper *)value
		  forField:(WasabiMetadataField)field
		 withIndex:(unsigned int)index
	  settingFlags:(WasabiMetadataFlags)flags
			 error:(NSError **)error;

@end
