//
//  WasabiMetadataFields.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/23/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#pragma once

#ifndef Nullsoft_Replicant_ObjC_WasabiMetadataFields_h
#define Nullsoft_Replicant_ObjC_WasabiMetadataFields_h


enum
{
	WasabiMetadataUnknownField = -1,      // MetadataKeys::UNKNOWN
	WasabiMetadataArtistField = 0,        // MetadataKeys::ARTIST
	WasabiMetadataAlbumArtistField = 1,   // MetadataKeys::ALBUM_ARTIST
	WasabiMetadataAlbumField = 2,         // MetadataKeys::ALBUM
	WasabiMetadataTitleField = 3,         // MetadataKeys::TITLE
	WasabiMetadataURLField = 4,           // MetadataKeys::URI
	WasabiMetadataGenreField = 5,         // MetadataKeys::GENRE
	WasabiMetadataYearField = 6,          // MetadataKeys::YEAR
	WasabiMetadataTrackField = 7,         // MetadataKeys::TRACK
	WasabiMetadataDiscField = 8,          // MetadataKeys::DISC
	WasabiMetadataBitrateField = 9,       // MetadataKeys::BITRATE
	WasabiMetadataComposerField = 10,     // MetadataKeys::COMPOSER
	WasabiMetadataPublisherField = 11,    // MetadataKeys::PUBLISHER
	WasabiMetadataBPMField = 12,          // MetadataKeys::BPM
	WasabiMetadataCommentField = 13,      // MetadataKeys::COMMENT
	WasabiMetadataDiscCountField = 14,    // MetadataKeys::DISKS
	WasabiMetadataFileSizeField = 15,     // MetadataKeys::FILE_SIZE
	WasabiMetadataFileTimeField = 16,     // MetadataKeys::FILE_TIME
	WasabiMetadataLengthField = 17,       // MetadataKeys::LENGTH
	WasabiMetadataPlayCountField = 18,    // MetadataKeys::PLAY_COUNT
	WasabiMetadataRatingField = 19,       // MetadataKeys::RATING
	WasabiMetadataServerField = 20,       // MetadataKeys::SERVER
	WasabiMetadataMimeTypeField = 21,     // MetadataKeys::MIME_TYPE
	WasabiMetadataTrackGainField = 22,    // MetadataKeys::TRACK_GAIN
	WasabiMetadataTrackPeakField = 23,    // MetadataKeys::TRACK_PEAK
	WasabiMetadataAlbumGainField = 24,    // MetadataKeys::ALBUM_GAIN
	WasabiMetadataAlbumPeakField = 25,    // MetadataKeys::ALBUM_PEAK
	WasabiMetadataTrackCountField = 26,   // MetadataKeys::TRACKS
};

typedef int WasabiMetadataField;

enum 
{
	WasabiMetadataExtenededFieldOffset = 1000,
};


enum
{
	WasabiMetadataEmptyFlag = 0,
	WasabiMetadataDataFlag = (1<<0),
	WasabiMetadataSourceInfoFlag = (1<<1),
	WasabiMetadataMimeTypeFlag = (1<<2),
	WasabiMetadataDescriptionFlag = (1<<3),
	WasabiMetadataAllFlags = WasabiMetadataDataFlag
						   | WasabiMetadataSourceInfoFlag
						   | WasabiMetadataMimeTypeFlag
						   | WasabiMetadataDescriptionFlag,
};

typedef int WasabiMetadataFlags;

#endif
