//
//  WasabiMetadataManager.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/23/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiDispatchable.h"
#import "WasabiServiceIdentity.h"

FOUNDATION_EXTERN CFUUIDRef const WasabiMetadataManagerGUID;
FOUNDATION_EXTERN CFUUIDRef const WasabiMetadataManagerTypeID;


@protocol WasabiMetadataManager <WasabiDispatchable, WasabiServiceIdentity>

@required
- (int)registerField:(NSString *)fieldName;
- (int)registerField:(NSString *)fieldName
			   error:(NSError **)error;

- (int)fieldKeyFromName:(NSString *)fieldName;
- (int)fieldKeyFromName:(NSString *)fieldName
				  error:(NSError **)error;

- (NSString *)fieldNameFromKey:(int)fieldKey;
- (NSString *)fieldNameFromKey:(int)fieldKey
						 error:(NSError **)error;

- (NSString *)genreNameFromId:(uint8_t)genreId;
- (NSString *)genreNameFromId:(uint8_t)genreId
						error:(NSError **)error;

- (uint8_t)genreIdFromName:(NSString *)genreName;
- (uint8_t)genreIdFromName:(NSString *)genreName
					 error:(NSError **)error;

- (BOOL)isSupportedFileURL:(NSURL *)fileURL;
- (BOOL)isSupportedFileURL:(NSURL *)fileURL
					 error:(NSError **)error;

@end
