//
//  WasabiMetadataService.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/23/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiDispatchable.h"
#import "WasabiMetadata.h"
#import "WasabiMetadataEditor.h"

FOUNDATION_EXTERN CFUUIDRef const WasabiMetadataServiceTypeID;


@protocol WasabiMetadataService <WasabiDispatchable>

@required

+ (CFUUIDRef)serviceType;

- (void)enumerateExtensionsUsingBlock:(void (^)(NSString *extension, BOOL *stop))block;

- (id<WasabiMetadata>)readerForURL:(NSURL *)fileURL
							 error:(NSError **)error;

- (id<WasabiMetadataEditor>)editorForURL:(NSURL *)fileURL
								   error:(NSError **)error;

- (id<WasabiMetadata>)deserializeFromData:(NSData *)data
									error:(NSError **)error;
@end
