//
//  WasabiReplicantError.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 5/8/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

FOUNDATION_EXTERN NSString *const WasabiReplicantErrorDomain;


@interface WasabiReplicantError : NSError

+ (NSError *)errorWithCode:(int)code 
		   underlyingError:(NSError *)underlyingError 
			 failureReason:(NSString *)failureReason
				  filePath:(NSString *)filePath;

+ (NSError *)errorWithCode:(int)code 
		   underlyingError:(NSError *)underlyingError 
			 failureReason:(NSString *)failureReason
					   url:(NSURL *)url;

+ (NSError *)errorWithCode:(int)code 
		   underlyingError:(NSError *)underlyingError 
			 failureReason:(NSString *)failureReason;

+ (NSError *)errorWithCode:(int)code 
		   underlyingError:(NSError *)underlyingError;

+ (NSError *)errorWithCode:(int)code 
			 failureReason:(NSString *)failureReason;

+ (NSError *)errorWithCode:(int)code;

@end


/* SET_REPLICANT_ERROR_AND_RETURN */
#define SET_REPLICANT_ERROR_AND_RETURN(__errorCode, __errorObject) \
do { \
__typeof__(__errorObject) __error = (__errorObject); \
if (NULL != (__error)) { \
*(__error) = [WasabiReplicantError errorWithCode:(__errorCode)]; }\
return;} while(0)

/* SET_REPLICANT_ERROR_AND_RETURN_VALUE */
#define SET_REPLICANT_ERROR_AND_RETURN_VALUE(__errorCode, __errorObject, __value) \
do { \
__typeof__(__errorObject) __error = (__errorObject); \
if (NULL != (__error)) { \
*(__error) = [WasabiReplicantError errorWithCode:(__errorCode)]; }\
return (__value);} while(0)

#define SET_REPLICANT_ERROR_AND_RETURN_NO(__errorCode, __errorObject) \
SET_REPLICANT_ERROR_AND_RETURN_VALUE(__errorCode, __errorObject, NO)

#define SET_REPLICANT_ERROR_AND_RETURN_NIL(__errorCode, __errorObject) \
SET_REPLICANT_ERROR_AND_RETURN_VALUE(__errorCode, __errorObject, nil)

#define SET_REPLICANT_ERROR_AND_RETURN_ZERO(__errorCode, __errorObject) \
SET_REPLICANT_ERROR_AND_RETURN_VALUE(__errorCode, __errorObject, 0)

/* CHECK_REPLICANT_CODE_SET_ERROR_AND_RETURN */
#define CHECK_REPLICANT_CODE_SET_ERROR_AND_RETURN(__errorCode, __errorObject)\
do { __typeof__(__errorCode) __code = (__errorCode); \
if (NErr_Success != __code) { SET_REPLICANT_ERROR_AND_RETURN(__code, __errorObject); }} while(0)

/* CHECK_REPLICANT_CODE_SET_ERROR_AND_RETURN_VALUE */
#define CHECK_REPLICANT_CODE_SET_ERROR_AND_RETURN_VALUE(__errorCode, __errorObject, __value)\
do { __typeof__(__errorCode) __code = (__errorCode); \
if (NErr_Success != __code) { SET_REPLICANT_ERROR_AND_RETURN_VALUE(__code, __errorObject, __value); }} while(0)

#define CHECK_REPLICANT_CODE_SET_ERROR_AND_RETURN_NO(__errorCode, __errorObject)\
CHECK_REPLICANT_CODE_SET_ERROR_AND_RETURN_VALUE(__errorCode, __errorObject, NO)

#define CHECK_REPLICANT_CODE_SET_ERROR_AND_RETURN_NIL(__errorCode, __errorObject)\
CHECK_REPLICANT_CODE_SET_ERROR_AND_RETURN_VALUE(__errorCode, __errorObject, nil)

#define CHECK_REPLICANT_CODE_SET_ERROR_AND_RETURN_ZERO(__errorCode, __errorObject)\
CHECK_REPLICANT_CODE_SET_ERROR_AND_RETURN_VALUE(__errorCode, __errorObject, 0)

