//
//  WasabiServiceFactory.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/18/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiDispatchable.h"

FOUNDATION_EXTERN CFUUIDRef const WasabiUniqueSeriveTypeID;

@protocol WasabiServiceFactory <WasabiDispatchable>

@required
- (CFUUIDRef)type;
- (NSString *)name;
- (CFUUIDRef)guid;

- (id)interfaceWithWrapperClass:(Class) wrapperClass;

- (BOOL)getInterface:(void**)interface; // Note: you must call Wasabi2::Dispatchable::Release() on returned instance.

- (void)sendNotificationMessage:(int)message;

- (void)sendNotificationMessage:(int)message 
					  withParam:(intptr_t)param;

- (void)sendNotificationMessage:(int)message 
					  withParam:(intptr_t)param1	
					  andParam2:(intptr_t)param2;

@end
