//
//  WasabiServiceManager.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/18/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiServiceFactory.h"
#import "WasabiDispatchable.h"

@protocol WasabiServiceManager <WasabiDispatchable>

@required
- (BOOL)registerService:(id<WasabiServiceFactory>)service
				  error:(NSError **)error;

- (BOOL)unregisterService:(id<WasabiServiceFactory>)service
					error:(NSError **)error;

- (size_t)serviceCountWithType:(CFUUIDRef)type;
- (void)enumerateServicesUsingBlock:(void (^)(id<WasabiServiceFactory> serviceFactory, BOOL *stop))block;
- (void)enumerateServicesWithType:(CFUUIDRef)type 
					   usingBlock:(void (^)(id<WasabiServiceFactory> serviceFactory, BOOL *stop))block;

- (id<WasabiServiceFactory>)serviceFactoryFromGUID:(CFUUIDRef)guid;
- (id)serviceInterfaceFromGUID:(CFUUIDRef)guid
			  withWrapperClass:(Class)wrapperClass;
- (id)serviceInterfaceWithWrapperClass:(Class)wrapperClass;
@end
