//
//  WasabiSysCallbackManager.h
//  replicant-objc
//
//  Created by Maksim Tyrtyshny on 4/19/12.
//  Copyright (c) 2012 Nullsoft, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WasabiDispatchable.h"
#import "WasabiServiceIdentity.h"
#import "WasabiSysCallback.h"

FOUNDATION_EXTERN CFUUIDRef const WasabiSysCallbackManagerGUID;
FOUNDATION_EXTERN CFUUIDRef const WasabiSysCallbackManagerTypeID;

@protocol WasabiSysCallbackManager <WasabiDispatchable, WasabiServiceIdentity>

@required
- (BOOL)registerCallback:(id<WasabiSysCallback>)callback
				   error:(NSError **)error;

- (BOOL)unregisterCallback:(id<WasabiSysCallback>)callback
					 error:(NSError **)error;

- (void)notifyWithEventType:(CFUUIDRef)eventTypeId 
					message:(int)message
					 param1:(intptr_t)param1
					 param2:(intptr_t)param2;

- (void)enumerateCallbacksWithEventType:(CFUUIDRef)eventTypeId
					usingBlock:(void (^)(id<WasabiSysCallback> callback, BOOL *stop))block;


- (void)enumerateCallbacksUsingBlock:(void (^)(id<WasabiSysCallback> callback, BOOL *stop))block;

@end
